%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Code to generate input_data of the grid for state estimation
%
% @author Andrea Angioni <aangioni@eonerc.rwth-aachen.de>
% @copyright 2018, Institute for Automation of Complex Power Systems, EONERC
% @license GNU General Public License (version 3)
%
% dsse
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [GridData] = generate_GridData(type_of_model,name_of_model)

GridData = struct; %this struct contains all the static data of the grid

if strcmp(type_of_model,'single_phase')==1 %single phase model
    
    %*******************************************************************
    % sample grid : subsitute with your grid data
    %run sample_singlephase1
    %run sample_singlephase2
    %run CIGRE_MV
    eval(name_of_model);
    %*******************************************************************
    
    R1 = R1/base_Z;
    X1 = X1/base_Z;
    Z1 = R1+1i*X1;
    Y1 = Z1.^-1;
    R2 = real(Y1);%conductance
    X2 = imag(Y1);%susceptance

elseif strcmp(type_of_model,'three_phase_sequence')==1 % the system is modeled as three phase using the sequences [positive, negative, zero] 
    
    %*******************************************************************
    % sample grid : subsitute with your grid data
    %run sample_threephase1
    eval(name_of_model);
    %*******************************************************************

    parameters_R_pos = R1/base_Z; 
    parameters_X_pos = X1/base_Z; 
    parameters_R_zero =  R1/base_Z; 
    parameters_X_zero = X1/base_Z; 
    R1=zeros(3,3*Lines_num);
    X1=zeros(3,3*Lines_num);
    B1=zeros(3,3*Lines_num);
    G1=zeros(3,3*Lines_num);
    R2=zeros(3,3*Lines_num);
    X2=zeros(3,3*Lines_num);
    
    a1_3=1/3; % it is a common factor to convert sequences to abc cordinates
    impedance_factor  = (base_power/((base_voltage)^2));
    
    for m = 1:Lines_num
        R1(1,3*m-2)  =a1_3*impedance_factor*(2*parameters_R_pos(m)+parameters_R_zero(m));
        R1(1,3*m-1)  =a1_3*impedance_factor*(  parameters_R_zero(m)-parameters_R_pos(m));
        R1(1,3*m)    =R1(1,3*m-1);
        R1(2,3*m-2)  =R1(1,3*m-1);
        R1(2,3*m-1)  =R1(1,3*m-2);
        R1(2,3*m)    =R1(1,3*m-1);
        R1(3,3*m-2)  =R1(1,3*m-1);
        R1(3,3*m-1)  =R1(1,3*m-1);
        R1(3,3*m)    =R1(1,3*m-2); %R1 series resistance
        R1temp = R1(1:3,3*m-2:3*m);
        X1(1,3*m-2)  =a1_3*impedance_factor*(2*parameters_X_pos(m)+parameters_X_zero(m));
        X1(1,3*m-1)  =a1_3*impedance_factor*(  parameters_X_zero(m)-parameters_X_pos(m));
        X1(1,3*m)    =X1(1,3*m-1);
        X1(2,3*m-2)  =X1(1,3*m-1);
        X1(2,3*m-1)  =X1(1,3*m-2);
        X1(2,3*m)    =X1(1,3*m-1);
        X1(3,3*m-2)  =X1(1,3*m-1);
        X1(3,3*m-1)  =X1(1,3*m-1);
        X1(3,3*m)    =X1(1,3*m-2); %X1 series reactance
        X1temp = X1(1:3,3*m-2:3*m);
        Z1temp = R1temp+1i*X1temp;
        Y1temp = inv(Z1temp);
        R2(1:3,3*m-2:3*m) = real(Y1temp);  %R1 inverse of series resistance
        X2(1:3,3*m-2:3*m) = imag(Y1temp);  %X1 inverse of series reactance
        B1(1:3,3*m-2:3*m) =zeros(3,3);
        G1(1:3,3*m-2:3*m) =zeros(3,3);
    end
    GridData.missing_phase = [];
    GridData.missing_line_phase = [];
    GridData.present_node=ones(3,Nodes_num);
    GridData.present_line=ones(3,Lines_num);
    
    
elseif strcmp(type_of_model,'three_phase_unbalance')==1 % the system is modeled as three phase using the three phase information (aa,bb,cc,ab,ac,bc)
    
    %*******************************************************************
    % sample grid : subsitute with your grid data
    %     base_power = 1e5;%Watts
    %     base_voltage = 400/sqrt(3);%Volts
    %     Nodes =            [1,2,3,4,5,6,7];%nodes names
    %     topology_initial =      [1,2,3,2,5,6];%initial nodes of each line
    %     topology_final   =      [2,3,4,5,6,7];%final nodes of each line
    %     Nodes_num = length(Nodes); %number of nodes in the grid
    %     Lines_num = length(topology_initial);%number of lines in the grid
    %     topology = [[1:Lines_num];topology_initial;topology_final];
    %     length_cable =          1e-3*[200   ,200     ,100  ,150    ,130   ,50 ];%length in km
    %
    %     Raa = [0.0035,0     ,0     ,0.0035,0.0035,0.038]; %resistance of phase a
    %     Rab = [0.0015,0     ,0     ,0.0015,0.0015,0];%resistance between phase a and b
    %     Rac = [0.0016,0     ,0     ,0.0016,0.0016,0];
    %     Rbb = [0.0030,0.0754,0     ,0.0030,0.0030,0];
    %     Rbc = [0.0014,0.0201,0     ,0.0014,0.0014,0];
    %     Rcc = [0.0032,0.0784,0.0524,0.0032,0.0032,0];
    %
    %     Xaa = [0.0149,0     ,0     ,0.0205,0.0205,0.877];%reactance of phase a
    %     Xab = [0.0055,0     ,0     ,0.0055,0.0055,0];
    %     Xac = [0.0046,0     ,0     ,0.0056,0.0056,0];
    %     Xbb = [0.0150,0.1001,0     ,0.0200,0.0200,0];
    %     Xbc = [0.0054,0.0359,0     ,0.0054,0.0054,0];
    %     Xcc = [0.0147,0.1004,0.0903,0.0202,0.0202,0];
    %*******************************************************************
    
    %*******************************************************************
    % sample grid : IEEE 123 grid
    base_power = 1e10;%Watts
    base_voltage = 4160/sqrt(3);%Volts
    Nodes =            1:1:119;%nodes names
   
    topology_initial =      1+[0,1,1,1,3,3,5,7,8 ,8, 8, 9, 13, 13, 14, 14, 15, 15, 18, 18, 19, 21, 21, 23, 23, 25, 25, 26, 26, 27, 28, 29, 30,  31, 34, 35, 35, 36, 36, 38, 40, 40, 42, 42, 44, 44, 45, 47, 47, 49, 50, 51,  52, 53, 54, 54, 55, 57, 57, 58, 60, 60, 62, 63, 64, 65, 67, 67, 67, 68, 69, 70, 72, 72, 73, 74, 76, 76, 77, 78, 78, 80, 81, 81, 82, 84, 86, 87, 87, 89, 89, 91, 91, 93, 93, 95, 97, 98, 99,  100    , 101, 101, 102, 103, 105, 105, 106, 108, 108, 109, 110, 110, 112, 113, 18,   13, 60, 97 ];
    topology_final   =      1+[1,2,3,7,4,5,6,8,12,9,13,14, 34, 18, 11, 10, 16, 17, 19, 21, 20, 22, 23, 24, 25, 26, 28, 27, 31, 33, 29, 30, 116, 32, 15, 36, 40, 37, 38, 39, 41, 42, 43, 44, 45, 47, 46, 48, 49, 50, 51, 115, 53, 54, 55, 57, 56, 58, 60, 59, 61, 62, 63, 64, 65, 66, 68, 72, 97, 69, 70, 71, 73, 76, 74, 75, 77, 86, 78, 79, 80, 81, 82, 84, 83, 85, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 98, 99, 100, 118    , 102, 105, 103, 104, 106, 108, 107, 109, 117, 110, 111, 112, 113, 114, 35,   52, 67, 101];
    length_cable =          [400,175,250,300,200,325,250,200,225,225,300,425,150,825,250,250,375,350,250,300,325,525,250,550,275,350,200,275,225,500,300,350,200,300,100,650,250,300,250,325,325,250,500,200,200,250,300,150,250,250,250,500,200,125,275,350,275,250,750,250,550,250,175,350,425,325,200,275,250,275,325,275,275,200,350,400,400,700,100,225,475,475,250,675,250,475,450,175,275,225,225,300,225,275,300,200,275,550,300,800,225,275,325,700,225,325,575,450,1000,300,575,125,525,325,375,400,350,250];

    Nodes_num = length(Nodes); %number of nodes in the grid
    Lines_num = length(topology_initial);%number of lines in the grid
    topology = [[1:Lines_num];topology_initial;topology_final];
    
    Raa = 0.000189394*[0.4576,0.0000,0.0000,0.4576,0.0000,0.0000,0.0000,0.4576,0.0000,1.3292,0.4576,1.3292,0.0000,0.4666,1.3292,1.3292,0.0000,0.0000,1.3292,0.4666,1.3292,0.0000,0.4666,0.0000,0.4666,0.4576,0.4666,0.4576,0.0000,1.3292,0.4666,0.4666,0.4666,0.0000,0.0000,0.4576,0.4576,1.3292,0.0000,0.0000,0.0000,0.4576,0.0000,0.4576,1.3292,0.4576,1.3292,0.4615,0.4615,0.4615,0.4615,0.4615,0.4576,0.4576,0.4576,0.4615,0.4576,0.0000,0.4615,0.0000,0.4666,1.5209,1.5209,1.5209,1.5209,1.5209,1.3292,0.4615,0.4615,1.3292,1.3292,1.3292,0.0000,0.4615,0.0000,0.0000,0.4576,0.4615,0.4576,0.4576,0.4576,0.4576,0.4576,0.0000,0.4576,0.0000,0.4576,1.3292,0.4576,0.0000,0.4576,0.0000,0.4576,1.3292,0.4576,0.0000,0.4615,0.4615,0.4615,0.4615,0.0000,0.4615,0.0000,0.0000,0.0000,0.4615,0.0000,1.3292,0.4615,1.3292,1.3292,1.3292,1.3292,1.3292,0.4615,0.4576,0.4576,0.4615];
    Rab = 0.000189394*[0.1560,0.0000,0.0000,0.1560,0.0000,0.0000,0.0000,0.1560,0.0000,0.0000,0.1560,0.0000,0.0000,0.1580,0.0000,0.0000,0.0000,0.0000,0.0000,0.1580,0.0000,0.0000,0.1580,0.0000,0.1580,0.0000,0.1580,0.0000,0.0000,0.0000,0.1580,0.1580,0.1580,0.0000,0.0000,0.1535,0.1560,0.0000,0.0000,0.0000,0.0000,0.1560,0.0000,0.1560,0.0000,0.1560,0.0000,0.1580,0.1580,0.1580,0.1580,0.1580,0.1560,0.1560,0.1560,0.1535,0.1560,0.0000,0.1535,0.0000,0.1560,0.5198,0.5198,0.5198,0.5198,0.5198,0.0000,0.1535,0.1535,0.0000,0.0000,0.0000,0.0000,0.1535,0.0000,0.0000,0.1535,0.1535,0.1535,0.1535,0.1535,0.1535,0.1535,0.0000,0.1535,0.0000,0.1535,0.0000,0.1535,0.0000,0.1535,0.0000,0.1535,0.0000,0.1535,0.0000,0.1535,0.1535,0.1535,0.1535,0.0000,0.1535,0.0000,0.0000,0.0000,0.1535,0.0000,0.0000,0.1535,0.0000,0.0000,0.0000,0.0000,0.0000,0.1580,0.1560,0.1535,0.1535];
    Rac = 0.000189394*[0.1535,0.0000,0.0000,0.1535,0.0000,0.0000,0.0000,0.1535,0.0000,0.0000,0.1535,0.0000,0.0000,0.1560,0.0000,0.0000,0.0000,0.0000,0.0000,0.1560,0.0000,0.0000,0.1560,0.0000,0.1560,0.1535,0.1560,0.1535,0.0000,0.0000,0.1560,0.1560,0.1560,0.0000,0.0000,0.0000,0.1535,0.0000,0.0000,0.0000,0.0000,0.1535,0.0000,0.1535,0.0000,0.1535,0.0000,0.1535,0.1535,0.1535,0.1535,0.1535,0.1535,0.1535,0.1535,0.1580,0.1535,0.0000,0.1580,0.0000,0.1580,0.4924,0.4924,0.4924,0.4924,0.4924,0.0000,0.1580,0.1580,0.0000,0.0000,0.0000,0.0000,0.1580,0.0000,0.0000,0.1560,0.1580,0.1560,0.1560,0.1560,0.1560,0.1560,0.0000,0.1560,0.0000,0.1560,0.0000,0.1560,0.0000,0.1560,0.0000,0.1560,0.0000,0.1560,0.0000,0.1580,0.1580,0.1580,0.1580,0.0000,0.1580,0.0000,0.0000,0.0000,0.1580,0.0000,0.0000,0.1580,0.0000,0.0000,0.0000,0.0000,0.0000,0.1535,0.1535,0.1560,0.1580];
    Rbb = 0.000189394*[0.4666,1.3292,0.0000,0.4666,0.0000,0.0000,0.0000,0.4666,1.3292,0.0000,0.4666,0.0000,0.0000,0.4615,0.0000,0.0000,0.0000,0.0000,0.0000,0.4615,0.0000,1.3292,0.4615,0.0000,0.4615,0.0000,0.4615,0.0000,0.0000,0.0000,0.4615,0.4615,0.4615,0.0000,0.0000,0.4615,0.4666,0.0000,1.3292,1.3292,0.0000,0.4666,1.3292,0.4666,0.0000,0.4666,0.0000,0.4666,0.4666,0.4666,0.4666,0.4666,0.4666,0.4666,0.4666,0.4576,0.4666,1.3292,0.4576,1.3292,0.4576,1.5329,1.5329,1.5329,1.5329,1.5329,0.0000,0.4576,0.4576,0.0000,0.0000,0.0000,0.0000,0.4576,0.0000,0.0000,0.4615,0.4576,0.4615,0.4615,0.4615,0.4615,0.4615,0.0000,0.4615,0.0000,0.4615,0.0000,0.4615,1.3292,0.4615,0.0000,0.4615,0.0000,0.4615,1.3292,0.4576,0.4576,0.4576,0.4576,0.0000,0.4576,0.0000,0.0000,1.3292,0.4576,1.3292,0.0000,0.4576,0.0000,0.0000,0.0000,0.0000,0.0000,0.4666,0.4666,0.4615,0.4576];
    Rbc = 0.000189394*[0.1580,0.0000,0.0000,0.1580,0.0000,0.0000,0.0000,0.1580,0.0000,0.0000,0.1580,0.0000,0.0000,0.1535,0.0000,0.0000,0.0000,0.0000,0.0000,0.1535,0.0000,0.0000,0.1535,0.0000,0.1535,0.0000,0.1535,0.0000,0.0000,0.0000,0.1535,0.1535,0.1535,0.0000,0.0000,0.0000,0.1580,0.0000,0.0000,0.0000,0.0000,0.1580,0.0000,0.1580,0.0000,0.1580,0.0000,0.1560,0.1560,0.1560,0.1560,0.1560,0.1580,0.1580,0.1580,0.1560,0.1580,0.0000,0.1560,0.0000,0.1535,0.5198,0.5198,0.5198,0.5198,0.5198,0.0000,0.1560,0.1560,0.0000,0.0000,0.0000,0.0000,0.1560,0.0000,0.0000,0.1580,0.1560,0.1580,0.1580,0.1580,0.1580,0.1580,0.0000,0.1580,0.0000,0.1580,0.0000,0.1580,0.0000,0.1580,0.0000,0.1580,0.0000,0.1580,0.0000,0.1560,0.1560,0.1560,0.1560,0.0000,0.1560,0.0000,0.0000,0.0000,0.1560,0.0000,0.0000,0.1560,0.0000,0.0000,0.0000,0.0000,0.0000,0.1560,0.1580,0.1580,0.1560];
    Rcc = 0.000189394*[0.4615,0.0000,1.3292,0.4615,1.3292,1.3292,1.3292,0.4615,0.0000,0.0000,0.4615,0.0000,1.3292,0.4576,0.0000,0.0000,1.3292,1.3292,0.0000,0.4576,0.0000,0.0000,0.4576,1.3292,0.4576,0.4615,0.4576,0.4615,1.3292,0.0000,0.4576,0.4576,0.4576,1.3292,1.3292,0.0000,0.4615,0.0000,0.0000,0.0000,1.3292,0.4615,0.0000,0.4615,0.0000,0.4615,0.0000,0.4576,0.4576,0.4576,0.4576,0.4576,0.4615,0.4615,0.4615,0.4666,0.4615,0.0000,0.4666,0.0000,0.4615,1.5209,1.5209,1.5209,1.5209,1.5209,0.0000,0.4666,0.4666,0.0000,0.0000,0.0000,1.3292,0.4666,1.3292,1.3292,0.4666,0.4666,0.4666,0.4666,0.4666,0.4666,0.4666,1.3292,0.4666,1.3292,0.4666,0.0000,0.4666,0.0000,0.4666,1.3292,0.4666,0.0000,0.4666,0.0000,0.4666,0.4666,0.4666,0.4666,1.3292,0.4666,1.3292,1.3292,0.0000,0.4666,0.0000,0.0000,0.4666,0.0000,0.0000,0.0000,0.0000,0.0000,0.4576,0.4615,0.4666,0.4666];
    
    Xaa = 0.000189394*[1.0780,0.0000,0.0000,1.0780,0.0000,0.0000,0.0000,1.0780,0.0000,1.3475,1.0780,1.3475,0.0000,1.0482,1.3475,1.3475,0.0000,0.0000,1.3475,1.0482,1.3475,0.0000,1.0482,0.0000,1.0482,1.0780,1.0482,1.0780,0.0000,1.3475,1.0482,1.0482,1.0482,0.0000,0.0000,1.0780,1.0780,1.3475,0.0000,0.0000,0.0000,1.0780,0.0000,1.0780,1.3475,1.0780,1.3475,1.0651,1.0651,1.0651,1.0651,1.0651,1.0780,1.0780,1.0780,1.0651,1.0780,0.0000,1.0651,0.0000,1.0482,0.7521,0.7521,0.7521,0.7521,0.7521,1.3475,1.0651,1.0651,1.3475,1.3475,1.3475,0.0000,1.0651,0.0000,0.0000,1.0780,1.0651,1.0780,1.0780,1.0780,1.0780,1.0780,0.0000,1.0780,0.0000,1.0780,1.3475,1.0780,0.0000,1.0780,0.0000,1.0780,1.3475,1.0780,0.0000,1.0651,1.0651,1.0651,1.0651,0.0000,1.0651,0.0000,0.0000,0.0000,1.0651,0.0000,1.3475,1.0651,1.3475,1.3475,1.3475,1.3475,1.3475,1.0651,1.0780,1.0780,1.0651];
    Xab = 0.000189394*[0.5017,0.0000,0.0000,0.5017,0.0000,0.0000,0.0000,0.5017,0.0000,0.0000,0.5017,0.0000,0.0000,0.4236,0.0000,0.0000,0.0000,0.0000,0.0000,0.4236,0.0000,0.0000,0.4236,0.0000,0.4236,0.0000,0.4236,0.0000,0.0000,0.0000,0.4236,0.4236,0.4236,0.0000,0.0000,0.3849,0.5017,0.0000,0.0000,0.0000,0.0000,0.5017,0.0000,0.5017,0.0000,0.5017,0.0000,0.4236,0.4236,0.4236,0.4236,0.5017,0.5017,0.5017,0.5017,0.3849,0.5017,0.0000,0.3849,0.0000,0.5017,0.2775,0.2775,0.2775,0.2775,0.2775,0.0000,0.3849,0.3849,0.0000,0.0000,0.0000,0.0000,0.3849,0.0000,0.0000,0.3849,0.3849,0.3849,0.3849,0.3849,0.3849,0.3849,0.0000,0.3849,0.0000,0.3849,0.0000,0.3849,0.0000,0.3849,0.0000,0.3849,0.0000,0.3849,0.0000,0.3849,0.3849,0.3849,0.3849,0.0000,0.3849,0.0000,0.0000,0.0000,0.3849,0.0000,0.0000,0.3849,0.0000,0.0000,0.0000,0.0000,0.0000,0.4236,0.5017,0.3849,0.3849];
    Xac = 0.000189394*[0.3849,0.0000,0.0000,0.3849,0.0000,0.0000,0.0000,0.3849,0.0000,0.0000,0.3849,0.0000,0.0000,0.5017,0.0000,0.0000,0.0000,0.0000,0.0000,0.5017,0.0000,0.0000,0.5017,0.0000,0.5017,0.3849,0.5017,0.3849,0.0000,0.0000,0.5017,0.5017,0.5017,0.0000,0.0000,0.0000,0.3849,0.0000,0.0000,0.0000,0.0000,0.3849,0.0000,0.3849,0.0000,0.3849,0.0000,0.3849,0.3849,0.3849,0.3849,0.3849,0.3849,0.3849,0.3849,0.4236,0.3849,0.0000,0.4236,0.0000,0.4236,0.2157,0.2157,0.2157,0.2157,0.2157,0.0000,0.4236,0.4236,0.0000,0.0000,0.0000,0.0000,0.4236,0.0000,0.0000,0.5017,0.4236,0.5017,0.5017,0.5017,0.5017,0.5017,0.0000,0.5017,0.0000,0.5017,0.0000,0.5017,0.0000,0.5017,0.0000,0.5017,0.0000,0.5017,0.0000,0.4236,0.4236,0.4236,0.4236,0.0000,0.4236,0.0000,0.0000,0.0000,0.4236,0.0000,0.0000,0.4236,0.0000,0.0000,0.0000,0.0000,0.0000,0.3849,0.3849,0.5017,0.4236];
    Xbb = 0.000189394*[1.0482,1.3475,0.0000,1.0482,0.0000,0.0000,0.0000,1.0482,1.3475,0.0000,1.0482,0.0000,0.0000,1.0651,0.0000,0.0000,0.0000,0.0000,0.0000,1.0651,0.0000,1.3475,1.0651,0.0000,1.0651,0.0000,1.0651,0.0000,0.0000,0.0000,1.0651,1.0651,1.0651,0.0000,0.0000,1.0651,1.0482,0.0000,1.3475,1.3475,0.0000,1.0482,1.3475,1.0482,0.0000,1.0482,0.0000,1.0482,1.0482,1.0482,1.0482,1.0482,1.0482,1.0482,1.0482,1.0780,1.0482,1.3475,1.0780,1.3475,1.0780,0.7162,0.7162,0.7162,0.7162,0.7162,0.0000,1.0780,1.0780,0.0000,0.0000,0.0000,0.0000,1.0780,0.0000,0.0000,1.0651,1.0780,1.0651,1.0651,1.0651,1.0651,1.0651,0.0000,1.0651,0.0000,1.0651,0.0000,1.0651,1.3475,1.0651,0.0000,1.0651,0.0000,1.0651,1.3475,1.0780,1.0780,1.0780,1.0780,0.0000,1.0780,0.0000,0.0000,1.3475,1.0780,1.3475,0.0000,1.0780,0.0000,0.0000,0.0000,0.0000,0.0000,1.0482,1.0482,1.0651,1.0780];
    Xbc = 0.000189394*[0.4236,0.0000,0.0000,0.4236,0.0000,0.0000,0.0000,0.4236,0.0000,0.0000,0.4236,0.0000,0.0000,0.3849,0.0000,0.0000,0.0000,0.0000,0.0000,0.3849,0.0000,0.0000,0.3849,0.0000,0.3849,0.0000,0.3849,0.0000,0.0000,0.0000,0.3849,0.3849,0.3849,0.0000,0.0000,0.0000,0.4236,0.0000,0.0000,0.0000,0.0000,0.4236,0.0000,0.4236,0.0000,0.4236,0.0000,0.5017,0.5017,0.5017,0.5017,0.5017,0.4236,0.4236,0.4236,0.5017,0.4236,0.0000,0.5017,0.0000,0.3849,0.2775,0.2775,0.2775,0.2775,0.2775,0.0000,0.5017,0.5017,0.0000,0.0000,0.0000,0.0000,0.5017,0.0000,0.0000,0.4236,0.5017,0.4236,0.4236,0.4236,0.4236,0.4236,0.0000,0.4236,0.0000,0.4236,0.0000,0.4236,0.0000,0.4236,0.0000,0.4236,0.0000,0.4236,0.0000,0.5017,0.5017,0.5017,0.5017,0.0000,0.5017,0.0000,0.0000,0.0000,0.5017,0.0000,0.0000,0.5017,0.0000,0.0000,0.0000,0.0000,0.0000,0.5017,0.4236,0.4236,0.5017];
    Xcc = 0.000189394*[1.0651,0.0000,1.3475,1.0651,1.3475,1.3475,1.3475,1.0651,0.0000,0.0000,1.0651,0.0000,1.3475,1.0780,0.0000,0.0000,1.3475,1.3475,0.0000,1.0780,0.0000,0.0000,1.0780,1.3475,1.0780,1.0651,1.0780,1.0651,1.3475,0.0000,1.0780,1.0780,1.0780,1.3475,1.3475,0.0000,1.0651,0.0000,0.0000,0.0000,1.3475,1.0651,0.0000,1.0651,0.0000,1.0651,0.0000,1.0780,1.0780,1.0780,1.0780,1.0780,1.0651,1.0651,1.0651,1.0482,1.0651,0.0000,1.0482,0.0000,1.0651,0.7521,0.7521,0.7521,0.7521,0.7521,0.0000,1.0482,1.0482,0.0000,0.0000,0.0000,1.3475,1.0482,1.3475,1.3475,1.0482,1.0482,1.0482,1.0482,1.0482,1.0482,1.0482,1.3475,1.0482,1.3475,1.0482,0.0000,1.0482,0.0000,1.0482,1.3475,1.0482,0.0000,1.0482,0.0000,1.0482,1.0482,1.0482,1.0482,1.3475,1.0482,1.3475,1.3475,0.0000,1.0482,0.0000,0.0000,1.0482,0.0000,0.0000,0.0000,0.0000,0.0000,1.0780,1.0651,1.0482,1.0482];

    
    %*******************************************************************
    
    impedance_factor  = (base_power/((base_voltage)^2));
    
    R1 = zeros(3,3*Lines_num);
    X1 = zeros(3,3*Lines_num);
    B1 = zeros(3,3*Lines_num);
    G1 = zeros(3,3*Lines_num);
    R2 = zeros(3,3*Lines_num);
    X2 = zeros(3,3*Lines_num);
    
    %case three phase with three phase matrixes
    R1(1,[1:3:3*Lines_num]) = Raa(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    R1(1,[2:3:3*Lines_num]) = Rab(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    R1(2,[1:3:3*Lines_num]) = Rab(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    R1(1,[3:3:3*Lines_num]) = Rac(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    R1(3,[1:3:3*Lines_num]) = Rac(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    R1(2,[2:3:3*Lines_num]) = Rbb(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    R1(2,[3:3:3*Lines_num]) = Rbc(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    R1(3,[2:3:3*Lines_num]) = Rbc(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    R1(3,[3:3:3*Lines_num]) = Rcc(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    
    
    X1(1,[1:3:3*Lines_num]) = Xaa(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    X1(1,[2:3:3*Lines_num]) = Xab(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    X1(2,[1:3:3*Lines_num]) = Xab(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    X1(1,[3:3:3*Lines_num]) = Xac(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    X1(3,[1:3:3*Lines_num]) = Xac(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    X1(2,[2:3:3*Lines_num]) = Xbb(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    X1(2,[3:3:3*Lines_num]) = Xbc(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    X1(3,[2:3:3*Lines_num]) = Xbc(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;
    X1(3,[3:3:3*Lines_num]) = Xcc(1:Lines_num).*length_cable(1:Lines_num) * impedance_factor;

    present_node=zeros(3,Nodes_num);
    present_line=zeros(3,Lines_num);
    %based on the the three phase information (aa,bb,cc,ab,ac,bc) of the PI
    %models, some matrices based on the connection of [3x3] blocks are
    %built. THese 3x3 blocks are the R,X,B,G components of the PI model of
    %that particular line. Depending on the missing phases there could be
    %some zeros in the matrices.
    for x = 1 : Lines_num
        if (Raa(x) ~= 0 || Xaa(x) ~= 0)  && (Rbb(x) ~= 0 && Xbb(x) ~= 0) && (Rcc(x) ~= 0 || Xcc(x) ~= 0)
            %3phases
            Z1 = R1(:,3*(x-1)+1 :3*x) + 1i*X1(:,3*(x-1)+1 :3*x);
            R2(:,3*(x-1)+1 :3*x) = real(inv(Z1));
            X2(:,3*(x-1)+1 :3*x) = imag(inv(Z1));
            present_line(:,x)=[1;1;1];
            present_node(:,topology(2,x)) = present_node(:,topology(2,x)) + present_line(:,x);
            present_node(:,topology(3,x)) = present_node(:,topology(3,x)) + present_line(:,x);
        end
        if (Raa(x) ~= 0 || Xaa(x) ~= 0)  && (Rbb(x) ~= 0 || Xbb(x) ~= 0) && (Rcc(x) == 0 || Xcc(x) == 0)
            %2phases (A and B)
            Z1 = R1(1:2,3*(x-1)+1 :3*(x-1)+2) + 1i*X1(1:2,3*(x-1)+1 :3*(x-1)+2);
            R2(1:2,3*(x-1)+1 :3*(x-1)+2) = real(inv(Z1));
            X2(1:2,3*(x-1)+1 :3*(x-1)+2) = imag(inv(Z1));
            present_line(:,x)=[1;1;0];
            present_node(:,topology(2,x)) = present_node(:,topology(2,x)) + present_line(:,x);
            present_node(:,topology(3,x)) = present_node(:,topology(3,x)) + present_line(:,x);
        end
        if (Raa(x) ~= 0 || Xaa(x) ~= 0)  && (Rbb(x) == 0 || Xbb(x) == 0) && (Rcc(x) ~= 0 || Xcc(x) ~= 0)
            %2phases (A and C)
            Z1 = R1([1,3],[3*(x-1)+1,3*(x-1)+3]) + 1i*X1([1,3],[3*(x-1)+1,3*(x-1)+3]);
            R2([1,3],[3*(x-1)+1,3*(x-1)+3]) = real(inv(Z1));
            X2([1,3],[3*(x-1)+1,3*(x-1)+3]) = imag(inv(Z1));
            present_line(:,x)=[1;0;1];
            present_node(:,topology(2,x)) = present_node(:,topology(2,x)) + present_line(:,x);
            present_node(:,topology(3,x)) = present_node(:,topology(3,x)) + present_line(:,x);
        end
        if (Raa(x) == 0 || Xaa(x) == 0)  && (Rbb(x) ~= 0 || Xbb(x) ~= 0) && (Rcc(x) ~= 0 || Xcc(x) ~= 0)
            %2phases (B and C)
            Z1 = R1(2:3,3*(x-1)+2 :3*(x-1)+3) + 1i*X1(2:3,3*(x-1)+2 :3*(x-1)+3);
            R2(2:3,3*(x-1)+2 :3*(x-1)+3) = real(inv(Z1));
            X2(2:3,3*(x-1)+2 :3*(x-1)+3) = imag(inv(Z1));
            present_line(:,x)=[0;1;1];
            present_node(:,topology(2,x)) = present_node(:,topology(2,x)) + present_line(:,x);
            present_node(:,topology(3,x)) = present_node(:,topology(3,x)) + present_line(:,x);
        end
        if (Raa(x) ~= 0 || Xaa(x) ~= 0)  && (Rbb(x) == 0 && Xbb(x) == 0) && (Rcc(x) == 0 && Xcc(x)== 0)
            %1phases (A)
            Z1 = R1(1,3*(x-1)+1) + 1i*X1(1,3*(x-1)+1);
            R2(1,3*(x-1)+1) = real(inv(Z1));
            X2(1,3*(x-1)+1) = imag(inv(Z1));
            present_line(:,x)=[1;0;0];
            present_node(:,topology(2,x)) = present_node(:,topology(2,x)) + present_line(:,x);
            present_node(:,topology(3,x)) = present_node(:,topology(3,x)) + present_line(:,x);
        end
        if (Raa(x) == 0 || Xaa(x) == 0)  && (Rbb(x) ~= 0 && Xbb(x) ~= 0) && (Rcc(x) == 0 && Xcc(x) == 0)
            %1phases (b)
            Z1 = R1(2,3*(x-1)+2) + 1i*X1(2,3*(x-1)+2);
            R2(2,3*(x-1)+2) = real(inv(Z1));
            X2(2,3*(x-1)+2) = imag(inv(Z1));
            present_line(:,x)=[0;1;0];
            present_node(:,topology(2,x)) = present_node(:,topology(2,x)) + present_line(:,x);
            present_node(:,topology(3,x)) = present_node(:,topology(3,x)) + present_line(:,x);
        end
        if (Raa(x) == 0 || Xaa(x) == 0)  && (Rbb(x) == 0 && Xbb(x) == 0) && (Rcc(x) ~= 0 && Xcc(x) ~= 0)
            %1phases (C)
            Z1 = R1(3,3*(x-1)+3) + 1i*X1(3,3*(x-1)+3);
            R2(3,3*(x-1)+3) = real(inv(Z1));
            X2(3,3*(x-1)+3) = imag(inv(Z1));
            present_line(:,x)=[0;0;1];
            present_node(:,topology(2,x)) = present_node(:,topology(2,x)) + present_line(:,x);
            present_node(:,topology(3,x)) = present_node(:,topology(3,x)) + present_line(:,x);
        end
    end
    missing_node_phase = [];
    for x = 1 : Nodes_num
        for f = 1 : 3
            if present_node(f,x) == 0
                missing_node_phase = [missing_node_phase,6*(x-1)+2*(f-1)+1,6*(x-1)+2*f];
            end
        end
    end
    missing_line_phase = [];
    for x = 1 : Lines_num
        for f = 1 : 3
            if present_line(f,x) == 0
                missing_line_phase = [missing_line_phase,6+6*(x-1)+2*(f-1)+1,6+6*(x-1)+2*f];
            end
        end
    end
    missing_node_phase = sort(missing_node_phase);
    GridData.missing_node_phase = missing_node_phase;
    missing_line_phase = sort(missing_line_phase);
    GridData.missing_line_phase = missing_line_phase;
    GridData.present_node=present_node;
    GridData.present_line=present_line;
end

A=zeros(Lines_num,Nodes_num);%logic matrix M lines X N nodes with A(m,n) = 1 if the node n is supplied by the line m
for m = 1 : Lines_num
    for n = 1 : Nodes_num
        if topology(3,m)== n
            A(m,n) = 1;
        elseif topology(2,m) == n
            for t = 1 : Lines_num
                if A(t,topology(2,m)) == 1
                    A(t,topology(3,m)) = 1;
                end
            end
        end
    end
end

% rearrange the information in GridData struct
GridData.type_of_model = type_of_model;
GridData.Nodes_num = Nodes_num;
GridData.Lines_num = Lines_num;
GridData.topology = topology;
GridData.base_power = base_power;
GridData.base_voltage = base_voltage;
GridData.base_current = GridData.base_power/base_voltage;
GridData.base_impedance = GridData.base_voltage/GridData.base_current;
GridData.R1 = R1;
GridData.X1 = X1;
GridData.B1 = B1;
GridData.G1 = G1;
GridData.R2 = R2;
GridData.X2 = X2;
GridData.A  = A;
GridData.inj_status = 0;
end